package jump.basics;

public class Iterator
{
	protected int idx;
}

template < class T > public final class SetIterator extends Iterator
{
	JumpSet< T > array;
public:
	SetIterator() {}
	SetIterator( SetIterator iterator ) { array = iterator.array; idx = iterator.idx; }
	SetIterator( JumpSet< T > vector, int index = 0 ) { array = vector; idx = index; }
	Object clone() { return new SetIterator( this ); }
	boolean equals( Object obj ) { return obj instanceof SetIterator && equals( (SetIterator) obj ); }
	boolean equals( SetIterator iter ) { return iter.idx == idx && iter.array == array; }
	boolean operator<( Iterator iter ) { return idx < iter.idx; }
	T get() { return array.getAt( idx ); }
	T get( int offset ) { return array.getAt( idx + offset ); }
	void put( int offset, T object ) { array.setAt( idx + offset, object ); }
	boolean atBegin() { return idx == 0; }
	boolean atEnd() { return idx == array.size(); }
	boolean hasMoreElements() { return idx < array.size(); }
	final T operator++() { return array.getAt( ++idx ); }
	final T operator++( int ) { return array.getAt( idx++ ); }
	final SetIterator operator+=( int n ) { idx+=n; return this; }
	final T operator--() { return array.getAt( --idx ); }
	final T operator--(int) { return array.getAt( idx-- ); }
	final SetIterator operator-=( int n ) { idx-=n; return this; }
	T nextElement() { return array.getAt( ++idx ); }
	T prevElement() { return array.getAt( --idx ); }
	void put( T t ) { array.setAt( idx, t ); }
	int distance( Iterator iter ) { return iter.idx - idx; }
	int index() { return idx; }
}

